#include <array>
#include <iostream>
#include <vector>
#include <deque>
#include <string>
#include <functional>
#include <iterator> // e.g. ostream_iterator
#include <algorithm> // e.g. unique

using namespace std;


template <typename Iter, typename Str>
void PrintTo(ostream& str, Iter beg, Iter end, Str astr)
{
   str << astr;
   copy(beg, end, ostream_iterator<int>(str, ";"));
}


/* entfernen Sie den Kommentar vor der folgenden Zeile und
   bringen Sie das Programm zum Laufen. An den Stellen 
   mit ... ist auf jeden Fall Ihr Input erforderlich.
   Sie koennen von Aufgabe 1 die vector, array, deque
   Loesung uebernehmen
   */
#define AUFGABE2
#ifdef AUFGABE2
template <typename CONT>
void PrintBeforeUniqueAfterTemp(CONT& cont)
{
   PrintTo(cout, cont.begin(), cont.end(), "Mit array: before: ");
   auto newEnd = unique(cont.begin(), cont.end());
   cout << endl;
   PrintTo(cout, cont.begin(), newEnd, "after:  ");
   cout << endl;
}



void aufgabe2()
{
   cout << "\nNun mit Templates\n";
   deque<int> dequeInt = { 1, 3, 3, 3, 5, 5, 7 };
   PrintBeforeUniqueAfterTemp(dequeInt);
   array<int, 7> arr = { 1, 3, 3, 3, 5, 5, 7 };
   PrintBeforeUniqueAfterTemp(arr);
   vector<int> vec = { 1, 3, 3, 3, 5, 5, 7 };
   PrintBeforeUniqueAfterTemp(vec);
}
#else

void aufgabe2()
{
}
#endif


